#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityTouchingFishLevelReward.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityTouchingFishLevelReward> M_ActivityTouchingFishLevelReward::msSingleton(nullptr);

int M_ActivityTouchingFishLevelReward::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTouchingFishLevelRewardData* M_ActivityTouchingFishLevelReward::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityTouchingFishLevelRewardData>& M_ActivityTouchingFishLevelReward::GetMapData()
{
	return mMapData;
}

void M_ActivityTouchingFishLevelReward::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityTouchingFishLevelReward::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTouchingFishLevelRewardData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* NorItem = element->Attribute("NorItem");
			std::vector<std::string> vecNorItem;
			boost::split(vecNorItem, NorItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNorItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNorItem[i].c_str(), &temp))
				{
					data.mNorItem.push_back(temp);
				}
			}
		}
		{
			const char* NorCount = element->Attribute("NorCount");
			std::vector<std::string> vecNorCount;
			boost::split(vecNorCount, NorCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNorCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNorCount[i].c_str(), &temp))
				{
					data.mNorCount.push_back(temp);
				}
			}
		}
		{
			const char* AdvItem = element->Attribute("AdvItem");
			std::vector<std::string> vecAdvItem;
			boost::split(vecAdvItem, AdvItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAdvItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAdvItem[i].c_str(), &temp))
				{
					data.mAdvItem.push_back(temp);
				}
			}
		}
		{
			const char* AdvCount = element->Attribute("AdvCount");
			std::vector<std::string> vecAdvCount;
			boost::split(vecAdvCount, AdvCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAdvCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAdvCount[i].c_str(), &temp))
				{
					data.mAdvCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityTouchingFishLevelReward::Load()
{
	Load("../Config/M_ActivityTouchingFishLevelReward.xml");
}

M_ActivityTouchingFishLevelReward* M_ActivityTouchingFishLevelReward::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTouchingFishLevelReward());
	}
	return msSingleton.get();
}
